<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Cus01300 extends \Zeedhi\Framework\Controller\Report{

    protected $birtStrategy;
    protected $environment;
    protected $reportService;

    public function __construct($reportService, $birtStrategy, $environment) {
        $this->reportService = $reportService;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;     
    }

    protected $reportMapping = array (
        'CUS01300' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG'         => 'P_NRORG',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'CDFILIAL'      => 'P_CDFILIAL',      
                'CDTIPOCUSTO'   => 'P_NRTIPOCUSTO',   
                'DTINICIAL'     => 'P_DTINICIAL',     
                'DTFINAL'       => 'P_DTFINAL',       
                'DTMESINIC'     => 'P_DTMESINIC',     
                'DTMESFINA'     => 'P_DTMESFINA',     
                'PRODUTOINIC'  => 'P_CDPRODINIC',    
                'PRODUTOFINA'   => 'P_CDPRODFINA',    
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',  
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS', 
                'NMTIPOCUSTO'   => 'P_NMTPCUSTO'
            ),
        )
    );
    

    public function createRemoteReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $this->beforeProcessReport($request, $response);
            $reportURL = $this->processReport($request);
            $response->addMessage(new DTO\Response\Message($reportURL));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["NRORG"] = $this->environment->getNrOrg();
        if (isset($row['QR2TYPE']) && $row['QR2TYPE']){
          $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        }
    }
}